diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
index 70dd32174..f99cb2d20 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
@@ -16,6 +16,7 @@ import net.minecraft.core.world.season.Seasons;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.ArrayList;
 import java.util.List;
 
 public class MobDeer
@@ -32,6 +33,8 @@ public class MobDeer
     private final int MAX_RUNAWAY_TIME = 200;
     private final int COUNTER_TIME = 30;
 
+    public List<WeightedRandomLootObject> burningMobDrops = new ArrayList<>();
+
     public MobDeer(World world)
     {
         super(world);
@@ -39,6 +42,7 @@ public class MobDeer
         setSize(0.9F, 1.3F);
         moveSpeed = 0.8F;
         mobDrops.add(new WeightedRandomLootObject(Items.FOOD_VENISON_RAW.getDefaultStack(), 1, 2));
+        burningMobDrops.add(new WeightedRandomLootObject(Items.FOOD_VENISON_COOKED.getDefaultStack(), 1, 2));
         this.age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 5, 14, MobAge.YEAR_LENGTH_DAYS * 4);
         this.jumpHeight = 0.5D;
     }
@@ -107,6 +111,18 @@ public class MobDeer
 
     }
 
+    @Override
+    protected List<WeightedRandomLootObject> getMobDrops()
+    {
+        if(remainingFireTicks > 0)
+        {
+            return burningMobDrops;
+        } else
+        {
+            return mobDrops;
+        }
+    }
+
     protected void findThreatNearby() {
         int dist = 10;
         Player player = world.getClosestPlayer(x, y, z, dist);
@@ -116,7 +132,7 @@ public class MobDeer
         }
 
         if(player == null){
-            List<MobWolf> nearbyWolves = world.getEntitiesWithinAABB(MobWolf.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(8D, 4D, 8D));
+            List<MobWolf> nearbyWolves = world.getEntitiesWithinAABB(MobWolf.class, AABB.fromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(8D, 4D, 8D));
             if (!nearbyWolves.isEmpty()) {
                 this.closestThreat = nearbyWolves.get(random.nextInt(nearbyWolves.size()));
                 return;
@@ -142,7 +158,7 @@ public class MobDeer
         double nDX = dX / sqrt;
         double nDZ = dZ / sqrt;
 
-        Vec3 safePoint = Vec3.getTempVec3(x + nDX * scale, y, z + nDZ * scale);
+        Vec3 safePoint = Vec3.fromPool(x + nDX * scale, y, z + nDZ * scale);
         pathToEntity = world.getEntityPathToXYZ(this, MathHelper.floor(safePoint.x), MathHelper.floor(y), MathHelper.floor(safePoint.z), 16F);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index 7ee1a5e65..3d5829f10 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -343,7 +343,7 @@ public class MobWolf
         {
             if(!isWolfTamed() && world.rand.nextInt(50) == 0){
                 List<MobAnimal> validTargets = new ArrayList<>();
-                List<MobAnimal> nearbyAnimals = world.getEntitiesWithinAABB(MobAnimal.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                List<MobAnimal> nearbyAnimals = world.getEntitiesWithinAABB(MobAnimal.class, AABB.fromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
                 if (!nearbyAnimals.isEmpty()) {
                     for(int i = 0; i < nearbyAnimals.size(); i++){
                         MobAnimal animal = nearbyAnimals.get(i);
@@ -360,7 +360,7 @@ public class MobWolf
             ItemStack heldItemSlot = getHeldItem();
             if((heldItemSlot == null || heldItemSlot.itemID <= 0)) {
                 List<EntityItem> triedItems = new ArrayList<>();
-                List<EntityItem> nearbyItems = world.getEntitiesWithinAABB(EntityItem.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                List<EntityItem> nearbyItems = world.getEntitiesWithinAABB(EntityItem.class, AABB.fromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
                 if (!nearbyItems.isEmpty()) {
                     while (triedItems.size() != nearbyItems.size())
                     {
@@ -605,7 +605,7 @@ public class MobWolf
                 }
                 if(attacker instanceof Mob)
                 {
-                    List<MobWolf> list = world.getEntitiesWithinAABB(MobWolf.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                    List<MobWolf> list = world.getEntitiesWithinAABB(MobWolf.class, AABB.fromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
                     Iterator<MobWolf> iterator = list.iterator();
                     do
                     {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
index 0bd600f44..01e948abf 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
@@ -43,7 +43,7 @@ public abstract class MobMonster extends MobPathfinder
             dX = dX * scaleFactor;
             dZ = dZ * scaleFactor;
 
-            Vec3 distanceXYZ = Vec3.getTempVec3(x + dX, y, z + dZ);
+            Vec3 distanceXYZ = Vec3.fromPool(x + dX, y, z + dZ);
             pathToEntity = world.getEntityPathToXYZ(this, MathHelper.floor(distanceXYZ.x), MathHelper.floor(y), MathHelper.floor(distanceXYZ.z), 16F);
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index c99403814..a12fe413a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -66,6 +66,7 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
+import java.util.function.Function;
 
 public abstract class Player
     extends Mob
@@ -228,7 +229,7 @@ public abstract class Player
         switch (state) {
             case MOTION_STATE_CROUCHED: {
                 final double heightOfMob = isDwarf() ? 0.5 : 1.5f;
-                return AABB.getTemporaryBB(
+                return AABB.fromPool(
                     this.x - center,
                     (this.y - (double) this.heightOffset) + (double) this.ySlideOffset,
                     this.z - center,
@@ -239,7 +240,7 @@ public abstract class Player
             case MOTION_STATE_DEFAULT:
             default: {
                 final double heightOfMob = isDwarf() ? 0.8 : 1.8f;
-                return AABB.getTemporaryBB(
+                return AABB.fromPool(
                     this.x - center,
                     (this.y - (double) this.heightOffset) + (double) this.ySlideOffset,
                     this.z - center,
@@ -890,6 +891,10 @@ public abstract class Player
     {
     }
 
+    public void displayNBTEditor(@Nullable CompoundTag tag, @Nullable Function<@NotNull CompoundTag, Void> exitAction) {
+
+    }
+
     public void displayWorkbenchScreen(int x, int y, int z)
     {
     }
@@ -999,7 +1004,7 @@ public abstract class Player
         {
             return;
         }
-        List<MobWolf> list = world.getEntitiesWithinAABB(MobWolf.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+        List<MobWolf> list = world.getEntitiesWithinAABB(MobWolf.class, AABB.fromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
         for (MobWolf wolf : list) {
             if (wolf.isWolfTamed() && wolf.getTarget() == null && uuid.equals(wolf.getWolfOwner()) && (!flag || !wolf.isWolfSitting())) {
                 wolf.setTarget(attacker);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
index d84b04c5a..ff85cdb33 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
@@ -165,11 +165,11 @@ public class Projectile extends Entity {
         ticksInAir++;
 
         HitResult movingobjectposition = getHitResult();
-        Vec3 oldPosition = Vec3.getTempVec3(x, y, z);
-        Vec3 newPosition = Vec3.getTempVec3(x + xd, y + yd, z + zd);
+        Vec3 oldPosition = Vec3.fromPool(x, y, z);
+        Vec3 newPosition = Vec3.fromPool(x + xd, y + yd, z + zd);
         if(movingobjectposition != null)
         {
-            newPosition = Vec3.getTempVec3(movingobjectposition.location.x, movingobjectposition.location.y, movingobjectposition.location.z);
+            newPosition = Vec3.fromPool(movingobjectposition.location.x, movingobjectposition.location.y, movingobjectposition.location.z);
         }
         if(!world.isClientSide)
         {
@@ -205,8 +205,8 @@ public class Projectile extends Entity {
         afterTick();
     }
     public HitResult getHitResult(){
-        Vec3 oldPosition = Vec3.getTempVec3(x, y, z);
-        Vec3 newPosition = Vec3.getTempVec3(x + xd, y + yd, z + zd);
+        Vec3 oldPosition = Vec3.fromPool(x, y, z);
+        Vec3 newPosition = Vec3.fromPool(x + xd, y + yd, z + zd);
         return world.checkBlockCollisionBetweenPoints(oldPosition, newPosition);
     }
     public void onHit(HitResult hitResult){
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
index b9056918c..dca7fa555 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
@@ -120,7 +120,7 @@ public class ProjectileArrow extends Projectile
         if(block != null)
         {
             AABB aabb = block.getCollisionBoundingBoxFromPool(world, xTile, yTile, zTile);
-            if(aabb != null && aabb.contains(Vec3.getTempVec3(x, y, z)))
+            if(aabb != null && aabb.contains(Vec3.fromPool(x, y, z)))
             {
                 setGrounded(true);
             }
@@ -154,8 +154,8 @@ public class ProjectileArrow extends Projectile
         super.tick();
     }
     public HitResult getHitResult(){
-        Vec3 oldPosition = Vec3.getTempVec3(x, y, z);
-        Vec3 newPosition = Vec3.getTempVec3(x + xd, y + yd, z + zd);
+        Vec3 oldPosition = Vec3.fromPool(x, y, z);
+        Vec3 newPosition = Vec3.fromPool(x + xd, y + yd, z + zd);
         return world.checkBlockCollisionBetweenPoints(oldPosition, newPosition, false, true, false);
     }
     public void onHit(HitResult hitResult){
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
index 9d5aaebe7..fd9e21429 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
@@ -45,8 +45,8 @@ public class ProjectileCannonballBouncy extends ProjectileCannonball
         float velocity = MathHelper.sqrt(xd * xd + yd * yd + zd * zd);
 
         // Check for block collision
-        Vec3 currentPos = Vec3.getTempVec3(x, y, z);
-        Vec3 nextPos = Vec3.getTempVec3(x + xd, y + yd - 0.25f, z + zd);
+        Vec3 currentPos = Vec3.fromPool(x, y, z);
+        Vec3 nextPos = Vec3.fromPool(x + xd, y + yd - 0.25f, z + zd);
         HitResult hit = world.checkBlockCollisionBetweenPoints(currentPos, nextPos, false, true, false);
         if(hit != null)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index b3ad57d07..2553bf9ae 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -243,7 +243,7 @@ public class EntityBoat extends Entity
         {
             double minY = (bb.minY + ((bb.maxY - bb.minY) * (double)(i)) / (double)waterSections) - 0.125D;
             double maxY = (bb.minY + ((bb.maxY - bb.minY) * (double)(i + 1)) / (double)waterSections) - 0.125D;
-            AABB axisalignedbb = AABB.getTemporaryBB(bb.minX, minY, bb.minZ, bb.maxX, maxY, bb.maxZ);
+            AABB axisalignedbb = AABB.fromPool(bb.minX, minY, bb.minZ, bb.maxX, maxY, bb.maxZ);
             if(world.isAABBInMaterial(axisalignedbb, Material.water))
             {
                 bouyancy += 1.0D / (double)waterSections;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index 1be41b0cf..911358920 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -1,7 +1,10 @@
 package net.minecraft.core.entity.vehicle;
 
 import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.IntTag;
 import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.ShortTag;
+import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicRail;
 import net.minecraft.core.block.Blocks;
@@ -134,7 +137,7 @@ public class EntityMinecart extends Entity implements Container {
 	protected void defineSynchedData() {
         entityData.define(DATA_TYPE, (byte)0, Byte.class);
         entityData.define(DATA_META, 0, Integer.class);
-        entityData.define(DATA_FUEL, (short)0, Short.class);
+        entityData.define(DATA_FUEL, 0, Integer.class);
     }
 
     public void setType(byte type) {entityData.set(DATA_TYPE, type);}
@@ -143,8 +146,8 @@ public class EntityMinecart extends Entity implements Container {
     public void setMeta(int meta) {entityData.set(DATA_META, meta);}
     public int getMeta() {return entityData.getInt(DATA_META);}
 
-    public void setFuel(short fuel) {entityData.set(DATA_FUEL, fuel);}
-    public short getFuel() {return entityData.getShort(DATA_FUEL);}
+    public void setFuel(int fuel) {entityData.set(DATA_FUEL, fuel);}
+    public int getFuel() {return entityData.getInt(DATA_FUEL);}
 
 
     @Override
@@ -529,7 +532,7 @@ public class EntityMinecart extends Entity implements Container {
             passenger = null;
         }
         if(didFurnacePush && random.nextInt(4) == 0) {
-            setFuel((short) (getFuel() - 1));
+            setFuel(getFuel() - 1);
             if(getFuel() < 0) {
                 xPush = 0.0D;
                 zPush = 0.0D;
@@ -625,7 +628,7 @@ public class EntityMinecart extends Entity implements Container {
         if(railsDY > 0.0D) {
             vecY += 0.5D;
         }
-        return Vec3.getTempVec3(vecX, vecY, vecZ);
+        return Vec3.fromPool(vecX, vecY, vecZ);
     }
 
     @Override
@@ -779,12 +782,12 @@ public class EntityMinecart extends Entity implements Container {
                 break;
             case FURNACE_CART:
                 ItemStack itemstack = player.inventory.getCurrentItem();
-                if(itemstack != null && LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) > 0) {
-                    if(--itemstack.stackSize <= 0)
+                if(itemstack != null && LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) > 0 && itemstack.consumeItem(player)) {
+                    if(itemstack.stackSize <= 0)
                     {
                         player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
                     }
-                    setFuel((short) (getFuel() + ((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID)/1600F) * 1200)));
+                    setFuel(getFuel() + MathHelper.round(((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID)/1600F) * 1200)));
                 }
                 xPush = x - player.x;
                 zPush = z - player.z;
@@ -813,7 +816,7 @@ public class EntityMinecart extends Entity implements Container {
             case FURNACE_CART:
                 tag.putDouble("PushX", xPush);
                 tag.putDouble("PushZ", zPush);
-                tag.putShort("Fuel", getFuel());
+                tag.putInt("Fuel", getFuel());
                 break;
         }
     }
@@ -837,7 +840,12 @@ public class EntityMinecart extends Entity implements Container {
             case FURNACE_CART:
                 xPush = tag.getDouble("PushX");
                 zPush = tag.getDouble("PushZ");
-                setFuel(tag.getShort("Fuel"));
+                Tag<?> t = tag.getTag("Fuel");
+                if (t instanceof ShortTag) {
+                    setFuel(((ShortTag) t).getValue());
+                } else if (t instanceof IntTag) {
+                    setFuel(((IntTag) t).getValue());
+                }
                 break;
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index bc62d1e4a..09b73dc9a 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -84,7 +84,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
 
     private static NamespaceID makeNamespaceID(final String string){ // This exists because java is idiotic
         try {
-            return NamespaceID.getPermanent(string);
+            return NamespaceID.fromPool(string).copyUnpooled();
         } catch (final HardIllegalArgumentException e) {
             throw new IllegalArgumentException(e);
         }
@@ -100,7 +100,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
                 stat = replaceItem.createStat(statID, nameKey);
             }
         } else {
-            stat = new StatItem(NamespaceID.getPermanent(this.namespaceID.namespace(), this.namespaceID.value() + "_" + statID), nameKey, this.id).registerStat();
+            stat = new StatItem(NamespaceID.fromPool(this.namespaceID.namespace(), this.namespaceID.value() + "_" + statID), nameKey, this.id).registerStat();
         }
 
         putStat(statID, stat);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
index 88d499739..76896042d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
@@ -30,7 +30,7 @@ public class ItemBoat extends Item
         double d = entityplayer.xo + (entityplayer.x - entityplayer.xo) * (double)f;
         double d1 = (entityplayer.yo + (entityplayer.y - entityplayer.yo) * (double)f + 1.62D) - (double)entityplayer.heightOffset;
         double d2 = entityplayer.zo + (entityplayer.z - entityplayer.zo) * (double)f;
-        Vec3 vec3 = Vec3.getTempVec3(d, d1, d2);
+        Vec3 vec3 = Vec3.fromPool(d, d1, d2);
         float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
         float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
         float f5 = -MathHelper.cos(-f1 * 0.01745329F);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
index 45971bf95..73fa99245 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
@@ -80,7 +80,7 @@ public class ItemBucketEmpty extends Item
             return;
         }
 
-        AABB box = AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1);
+        AABB box = AABB.fromPool(x, y, z, x + 1, y + 1, z + 1);
         List<MobCow> entities = world.getEntitiesWithinAABB(MobCow.class, box);
         if (!entities.isEmpty()) {
             itemStack.itemID = Items.BUCKET_MILK.id;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
index 4dea72b1b..2150ca357 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
@@ -47,7 +47,7 @@ public class ItemLabel extends Item
 		blockX += direction.getOffsetX();
 		blockY += direction.getOffsetY();
 		blockZ += direction.getOffsetZ();
-		AABB box = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
+		AABB box = AABB.fromPool(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
 		List<Entity> entities = world.getEntitiesWithinAABBExcludingEntity(null, box);
         for (Entity entity : entities) {
             if (!(entity instanceof Player) && entity instanceof Mob && !entity.hadNicknameSet) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
index 091c83f79..44edd94dc 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
@@ -73,7 +73,7 @@ public class ItemPaintBrush extends Item {
             blockX += direction.getOffsetX();
             blockY += direction.getOffsetY();
             blockZ += direction.getOffsetZ();
-            AABB box = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
+            AABB box = AABB.fromPool(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
             List<MobSheep> entities = world.getEntitiesWithinAABB(MobSheep.class, box);
             if (!entities.isEmpty()) {
                 MobSheep sheep = entities.get(0);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
index e9a861bc4..1e4939b8b 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -93,7 +93,7 @@ public class ItemPebble extends Item implements IDispensable
         {
             final int newMeta = meta + 1;
 
-            final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+            final AABB bbBox = AABB.fromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
             if (!world.checkIfAABBIsClear(bbBox) || !world.canPlaceOnSurfaceOfBlock(blockX, blockY - 1, blockZ))
             {
                 return false;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java
new file mode 100644
index 000000000..e4a730cdb
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java
@@ -0,0 +1,71 @@
+package net.minecraft.core.item;
+
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.slot.Slot;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.function.Function;
+
+public class ItemWandNBT extends Item{
+
+    public ItemWandNBT(String translationKey, String namespaceId, int id) {
+        super(translationKey, namespaceId, id);
+    }
+
+    @Override
+    public ItemStack onInventoryInteract(Player player, Slot slot, ItemStack stackInSlot, boolean isItemGrabbed) {
+        if (slot.getItemStack() != null) {
+            player.displayNBTEditor(slot.getItemStack().writeToNBT(new CompoundTag()), new Function<CompoundTag, Void>() {
+                @Override
+                public Void apply(CompoundTag tag) {
+                    slot.getItemStack().readFromNBT(tag);
+                    return null;
+                }
+            });
+        }
+        return stackInSlot;
+    }
+
+    @Override
+    public boolean hasInventoryInteraction() {
+        return true;
+    }
+
+    @Override
+    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced) {
+        TileEntity te = world.getTileEntity(blockX, blockY, blockZ);
+        if (te != null) {
+            CompoundTag tag = new CompoundTag();
+            te.writeToNBT(tag);
+            player.displayNBTEditor(tag, new Function<CompoundTag, Void>() {
+                @Override
+                public Void apply(CompoundTag tag) {
+                    te.readAdditionalData(tag);
+                    return null;
+                }
+            });
+            return true;
+        }
+        return false;
+    }
+
+    @Override
+    public boolean useItemOnEntity(ItemStack itemstack, Mob mob, Player player) {
+        CompoundTag tag = new CompoundTag();
+        mob.save(tag);
+        player.displayNBTEditor(tag, new Function<CompoundTag, Void>() {
+            @Override
+            public Void apply(CompoundTag tag) {
+                mob.load(tag);
+                return null;
+            }
+        });
+        return true;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index 2d7b24ffe..3a1e03ea1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -204,6 +204,7 @@ public final class Items {
     public static Item STATUE_PIGMAN;
     public static Item SIGN_PAINTED;
     public static Item DOUGH;
+    public static Item WAND_NBT;
 
     private static boolean hasInit = false;
     public static void init(){
@@ -428,5 +429,6 @@ public final class Items {
         FOOD_VENISON_RAW = (new ItemFood("food.venison.raw", "minecraft:item/food_venison_raw", 16550, 3, 16, true, 4));
         FOOD_VENISON_COOKED = (new ItemFood("food.venison.cooked", "minecraft:item/food_venison_cooked", 16551, 12, 8, true, 4));
         DOUGH = (new Item("dough", "minecraft:item/dough", 16552));
+        WAND_NBT = new ItemWandNBT("wand.nbt", "minecraft:item/wand_nbt", 16553);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
index 496956ef2..527bf67f7 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
@@ -47,7 +47,7 @@ public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T>
 
 			final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+			final AABB bbBox = AABB.fromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
 			if (!world.checkIfAABBIsClear(bbBox))
 			{
 				return false;
@@ -92,7 +92,7 @@ public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T>
 
 			final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+			final AABB bbBox = AABB.fromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
 			if (!world.checkIfAABBIsClear(bbBox))
 			{
 				return false;
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
index 2763ce2d4..a43036a2f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
@@ -48,7 +48,7 @@ public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemB
 
 			final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+			final AABB bbBox = AABB.fromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
 			if (!world.checkIfAABBIsClear(bbBox))
 			{
 				return false;
@@ -93,7 +93,7 @@ public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemB
 
 			final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+			final AABB bbBox = AABB.fromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
 			if (!world.checkIfAABBIsClear(bbBox))
 			{
 				return false;
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index eb7b965d0..c7fe9ea9d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -46,7 +46,7 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T>
         {
         	if ((side == Side.TOP && meta == 0) || (side == Side.BOTTOM && meta == 2))
         	{
-                AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX +1f, blockY +1f, blockZ +1f);
+                AABB bbBox = AABB.fromPool(blockX, blockY, blockZ, blockX +1f, blockY +1f, blockZ +1f);
                 if(!world.checkIfAABBIsClear(bbBox))
                     return false;
 
@@ -73,7 +73,7 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T>
         {
         	if ((yPlaced > 0.5f && meta == 0) || (yPlaced <= 0.5f && meta == 2) || (side == Side.BOTTOM && meta == 0) || (side == Side.TOP && meta == 2))
         	{
-                AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX +1f, blockY +1f, blockZ +1f);
+                AABB bbBox = AABB.fromPool(blockX, blockY, blockZ, blockX +1f, blockY +1f, blockZ +1f);
                 if(!world.checkIfAABBIsClear(bbBox))
                     return false;
 
